/*
 * prop_page_top.c  -- profile setting property subpage
 *
 * $Id: prop_subpage_top.c,v 1.5 2004/03/13 17:40:40 hos Exp $
 *
 */

#include <windows.h>
#include <prsht.h>
#include "main.h"
#include "util.h"


/* page proc alist */
struct uint_ptr_pair top_setting_subpage[];
static struct uint_ptr_pair command_proc_map[];


/* implementations */

/* WM_INITDIALOG */
static INT_PTR top_setting_init_dialog(HWND hwnd, UINT msg,
                                       WPARAM wparam, LPARAM lparam,
                                       prop_page_context_t *ctx)
{
    struct uint_ptr_pair id_item_map[] = {
        {IDC_EDIT_PROFILE_NAME, &ctx->top.name},

        {0, NULL}
    };

    get_dialog_item(hwnd, id_item_map);
    ctx->command_proc = command_proc_map;

    SetWindowTextW(ctx->top.name, ctx->data->conf.profile_name);

    return TRUE;
}

/* WM_SUBPAGE_CHANGE */
static INT_PTR top_setting_change(HWND hwnd, UINT msg,
                                  WPARAM wparam, LPARAM lparam,
                                  prop_page_context_t *ctx)
{
    SetWindowTextW(ctx->top.name, ctx->data->conf.profile_name);

    return TRUE;
}

/* BN_CLICKED for save */
static INT_PTR top_save_clicked(HWND hwnd,
                                WORD code, WORD id, HWND ctrl,
                                prop_page_context_t *ctx)
{
    /* todo: save profile */
    return TRUE;
}

/* BN_CLICKED for load */
static INT_PTR top_load_clicked(HWND hwnd,
                                WORD code, WORD id, HWND ctrl,
                                prop_page_context_t *ctx)
{
    /* todo: load profile */
    return TRUE;
}

/* BN_CLICKED for load def */
static INT_PTR top_load_def_clicked(HWND hwnd,
                                    WORD code, WORD id, HWND ctrl,
                                    prop_page_context_t *ctx)
{
    if(display_message_box(IDS_MSG_CONFIRM_LOAD, IDS_MSG_LOAD_DEFAULT,
                           ctx->page_hwnd, MB_YESNO | MB_ICONQUESTION) !=
       IDYES) {
        return TRUE;
    }

    load_default_setting(ctx->data);

    SendMessage(ctx->page_hwnd, WM_MAIN_TREE_CHANGE, MAIN_TREE_REBUILD, 0);

    PropSheet_Changed(ctx->data->sheet_hwnd, ctx->page_hwnd);

    return TRUE;
}

/* EN_KILLFOCUS */
static INT_PTR top_name_killfocus(HWND hwnd,
                                  WORD code, WORD id, HWND ctrl,
                                  prop_page_context_t *ctx)
{
    LPWSTR name;
    int len;

    len = GetWindowTextLengthW(ctx->top.name);
    if(len <= 0) {
        display_message_box(IDS_MSG_ENTER_PROFILE_NAME, IDS_MSG_ERROR,
                            ctx->page_hwnd, MB_OK | MB_ICONWARNING);
        SetWindowTextW(ctx->top.name, ctx->data->conf.profile_name);
        SetFocus(ctx->top.name);
        return TRUE;
    }

    name = ctx->data->conf.profile_name;
    name = (LPWSTR)realloc(name, sizeof(WCHAR) * (len + 1));
    if(name == NULL) {
        return FALSE;
    }

    GetWindowTextW(ctx->top.name, name, len + 1);
    ctx->data->conf.profile_name = name;

    SendMessage(ctx->page_hwnd, WM_MAIN_TREE_CHANGE,
                MAIN_TREE_ROOTNAME, (LPARAM)name);

    return TRUE;
}


/* page proc alist */
struct uint_ptr_pair top_setting_subpage[] = {
    {WM_INITDIALOG, top_setting_init_dialog},
    {WM_SUBPAGE_CHANGE, top_setting_change},
    {WM_COMMAND, window_command_proc},

    {0, NULL}
};


/* WM_COMMAND */
static struct uint_ptr_pair save_proc_map[] = {
    {BN_CLICKED, top_save_clicked},

    {0, NULL}
};
static struct uint_ptr_pair load_proc_map[] = {
    {BN_CLICKED, top_load_clicked},

    {0, NULL}
};
static struct uint_ptr_pair load_def_proc_map[] = {
    {BN_CLICKED, top_load_def_clicked},

    {0, NULL}
};
static struct uint_ptr_pair name_proc_map[] = {
    {EN_KILLFOCUS, top_name_killfocus},

    {0, NULL}
};
static struct uint_ptr_pair command_proc_map[] ={
    {IDC_BTN_SAVE_PROFILE, &save_proc_map},
    {IDC_BTN_LOAD_PROFILE, &load_proc_map},
    {IDC_BTN_LOAD_DEF_PROFILE, &load_def_proc_map},
    {IDC_EDIT_PROFILE_NAME, &name_proc_map},

    {0, NULL}
};
